﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace WindowsFormsApplication1
{
    public class TMatrix
    {
        public int size;
        public TComplex[,] a;
        public TComplex[] y;
        public TComplex[] x;

        public TMatrix(int sizeM)
        {
            size = sizeM;
            a = new TComplex[size, size];
            y = new TComplex[size];
            x = new TComplex[size];
        }


        public void MultMatrixRight(TMatrix matrix2, int p, int q)
        {
            int i, j, k;
            double[,] al = new double[size, size];
            double[] yl = new double[size];
            for (i = 0; i < size; i++)
            {
                for (j = 0; j < size; j++)
                {
                    al[i, j] = 0.0;
                    for (k = 0; k < size; k++)
                    {
                        al[i, j] = al[i, j] + (a[i, k].real * matrix2.a[k, j].real);
                    }
                }


            }
            for (i = 0; i < size; i++)
            {
                for (j = 0; j < size; j++)
                {
                    a[i, j].real = al[i, j];
                }
            }
        }

        public void MultTranspMatrixLeft(TMatrix matrix2, int p, int q)
        {
            int i, j, k;
            double[,] al = new double[size, size];
            double[] yl = new double[size];
            for (i = 0; i < size; i++)
            {
                if ((i == p) || (i == q)) // only calculate row p and q
                {
                    yl[i] = 0.0;
                    for (j = 0; j < size; j++)
                    {
                        al[i, j] = 0.0;
                        for (k = 0; k < size; k++)
                        {
                            al[i, j] = al[i, j] + (matrix2.a[k, i].real * a[k, j].real);
                        }
                    }
                }
                else
                {
                    for (j = 0; j < size; j++)
                    {
                        al[i, j] = a[i, j].real;
                    }
                }
            }
            for (i = 0; i < size; i++)
            {
                for (j = 0; j < size; j++)
                {
                    a[i, j].real = al[i, j];
                }
            }
        }


        public void MultMatrixLeft(TMatrix matrix2, int p, int q)
        {
            int i, j, k;
            double[,] al = new double[size, size];
            double[] yl = new double[size];
            for (i = 0; i < size; i++)
            {
                if ((i == p) || (i == q)) // only calculate row p and q
                {
                    yl[i] = 0.0;
                    for (j = 0; j < size; j++)
                    {
                        al[i, j] = 0.0;
                        for (k = 0; k < size; k++)
                        {
                            al[i, j] = al[i, j] + (matrix2.a[i, k].real * a[k, j].real);
                        }
                    }

                }
                else
                {
                    for (j = 0; j < size; j++)
                    {
                        al[i, j] = a[i, j].real;
                    }
                }
            }
            for (i = 0; i < size; i++)
            {
                for (j = 0; j < size; j++)
                {
                    a[i, j].real = al[i, j];
                }
            }
        }

        public void SwitchRows(int n)
        {
            double tempD;
            int i, j;
            for (i = n; i <= size - 2; i++)
            {
                for (j = 0; j <= size - 1; j++)
                {
                    tempD = a[i, j].real;
                    a[i, j].real = a[i + 1, j].real;
                    a[i + 1, j].real = tempD;

                    tempD = a[i, j].imag;
                    a[i, j].imag = a[i + 1, j].imag;
                    a[i + 1, j].imag = tempD;
                }
                tempD = y[i].real;
                y[i].real = y[i + 1].real;
                y[i + 1].real = tempD;

                tempD = y[i].imag;
                y[i].imag = y[i + 1].imag;
                y[i + 1].imag = tempD;
            }
        }
    }

}
